SystemOrganization addCategory: #ConfigurationOfKEGGeneratorInlining!

Object subclass: #ConfigurationOfKEGGeneratorInlining
	instanceVariableNames: 'project'
	classVariableNames: 'LastVersionLoad'
	poolDictionaries: ''
	category: 'ConfigurationOfKEGGeneratorInlining'!

!ConfigurationOfKEGGeneratorInlining commentStamp: '<historical>' prior: 0!
A ConfigurationOfKEGGeneratorInlining is used to load and install the KEGGeneratorInlining related Methods into Pharo 2.0 Smalltalk.  See below for the Smalltalk code lines that you can evaluate in order to load and install the two main code variants.  With tests and withOut tests.

	This Class is licensed as MIT Open Source.  Please evaluate ( Object licenseMIT ) for more info
	or see KEGLicense class>>licenseMIT.
	
See the web page at http://ss3.gemstone.com/ss/KEGGeneratorInlining.html/Overview.  If that page no longer exists then The main documentation is in the public Methods in the KEGGenerator Class which all have long comments. There are 8 TestCase(s) which you can find in the test runner by looking for the KEGTestCaseObject Class and selecting its subClass KEGGeneratorTest to run the tests. These tests are designed to show lots of examples of how to get the basic functionality of each generator Method to work. They show basic one line examples of each Method but they don`t really give a flavor of how these KEGGenerators are used in practice.  For that we need an example project that uses KEGGenerators to do something.  But we don't have that yet.  It exists in Dolphin Smalltalk but not in Pharo yet.

You can evaluate the following lines of code to load and install various parts of the KEGGeneratorInlining codes.

To install the KEGGeneratorInlining and its supporting Classes and loose Methods evaluate: 
( ( ConfigurationOfKEGGeneratorInlining project version: '1.0' ) load )"<---[ tested ]"
or
( ( ConfigurationOfKEGGeneratorInlining project version: '1.0' ) load: 'default' )"<---[ not tested ]"
or
( ( ConfigurationOfKEGGeneratorInlining project version: '1.0' ) load: 'Core' )"<---[ not tested ]"
or
( ( ConfigurationOfKEGGeneratorInlining project version: '1.0' ) load: 'CompleteWithoutTests' )"<---[ not tested ]"
which should all be equivalent to each other.

To install the KEGGeneratorInlining and its supporting Methods and all the tests of those Methods evaluate:
( ( ConfigurationOfKEGGeneratorInlining project version: '1.0' ) load: 'Tests' )"<---[ tested ]"
or
( ( ConfigurationOfKEGGeneratorInlining project version: '1.0' ) load: 'CompleteWithTests' )"<---[ not tested ]"
which should be equivalent to each other.

There are other ways that you can load the Classes using >>load: but they have a high chance of not working right.  So I would stick to the cases listed above.

Contact me at picoVerse att gMail dott com. There is a google group for this library at https://groups.google.com/forum/?hl=en&fromgroups=#!!forum/keggenerators . KEGGenerators now work with Pharo 2.0 .

Here is the overview from the webpage at :
http://ss3.gemstone.com/ss/KEGGeneratorInlining.html/Overview
in case that webPage no longer exists.

The KEGGeneratorInlining library will help you to concatenate KEGGenerators together into larger sequences.  The >>inlineEmbeddedSequencesDeep: Method can help you to take any tree structure and convert it into a KEGGenerator sequence.  This can be used for depth first tree walking etc.  Or if you have a sequence/Collections with embedded sequences/Collections inside of it forming a kind of tree structure and you want that tree to be flattened out into a single sequence then use >>inlineEmbeddedSequencesDeep .  If you just want sequences to be concatenated together in an efficient way then use >>inlineEmbeddedSequences .  If you have a sequence and you want to inject other sequences into it at specific points along the way then use the >>disperse: Method which can also be used for concatenation.  There are several other Methods which can also be used namely: >>collect:seperatedBy: >>repeat: and >>seperatedBy: .
KEGGeneratorInlining is a library that implements Smalltalk Generators like those found in the book A Little Smalltalk. It is well documented in the Method comments. The main documentation is in the public Methods in the KEGGenerator Class that all have long comments. There are 8 TestCase(s) which you can find in the test runner by looking for the KEGTestCaseObject Class and selecting its KEGGenerator subClass to run the tests. These tests are designed to show lots of examples of how to get the basic functionality of each generator Method to work. They show basic one line examples of each Method but they don`t really give a flavor of how KEGGenerators are used in practice.  Here is how you load the KEGGeneratorInlining Packages into a virgin image. First you open the Monticello browser. Hit the +Repository button. Select HTTP. Below on this webpage see the Monticello Registration. Click on it and copy the text String. Right click copy. Paste the String into the Monticello dialog. Click OK. A new Repository browser will open. In the left pane click on the ConfigurationOfKEGGeneratorInlining Package .mcz file with the highest version number. It should look something like ConfigurationOfKEGGeneratorInlining-KjellGodo.1.mcz. Click the Load button. It should load. Now open a Workspace. and evaluate the following to exclude the testing Packages : ( ( ConfigurationOfKEGGeneratorInlining project version: '1.0' ) load ). Now to include the testing Packages evaluate the following : ( ( ConfigurationOfKEGGeneratorInlining project version: '1.0' ) load: 'Tests' ) I hope you will give KEGGeneratorInlining a try. Contact me at picoVerse att gMail dott com. There is a google group for this library at https://groups.google.com/forum/?hl=en&fromgroups=#!!forum/keggenerators . KEGGeneratorInlining now work with Pharo 2.0.


!

!ConfigurationOfKEGGeneratorInlining class methodsFor: 'development support' stamp: 'KjellGodo 5/12/2013 11:00'!
DevelopmentSupport

"See the methods in the 'development support' category on the class-side of MetacelloBaseConfiguration. Decide what development support methods you would like to use and copy them the the class-side of your configuration."
	<apiDocumentation>
! !

!ConfigurationOfKEGGeneratorInlining class methodsFor: 'private' stamp: 'KjellGodo 5/12/2013 11:00'!
baseConfigurationClassIfAbsent: aBlock

	^Smalltalk
		at: #MetacelloBaseConfiguration
		ifAbsent: [ 
			self ensureMetacelloBaseConfiguration.
			Smalltalk at: #MetacelloBaseConfiguration ifAbsent: aBlock ].
! !

!ConfigurationOfKEGGeneratorInlining class methodsFor: 'private' stamp: 'KjellGodo 5/12/2013 11:00'!
ensureMetacello

	(self baseConfigurationClassIfAbsent: []) ensureMetacello! !

!ConfigurationOfKEGGeneratorInlining class methodsFor: 'private' stamp: 'KjellGodo 5/12/2013 11:00'!
ensureMetacelloBaseConfiguration

	Smalltalk
		at: #MetacelloBaseConfiguration
		ifAbsent: [ 
			| repository version |
			repository := MCHttpRepository location: 'http://seaside.gemstone.com/ss/metacello' user: '' password: ''.
			repository
				versionReaderForFileNamed: 'Metacello-Base-DaleHenrichs.2.mcz'
				do: [ :reader | 
					version := reader version.
					version load.
					version workingCopy repositoryGroup addRepository: repository ] ]! !

!ConfigurationOfKEGGeneratorInlining class methodsFor: 'metacello tool support' stamp: 'KjellGodo 5/12/2013 11:00'!
isMetacelloConfig
	"Answer true and the Metacello tools will operate on you"
	
	^true! !

!ConfigurationOfKEGGeneratorInlining class methodsFor: 'loading' stamp: 'KjellGodo 5/12/2013 11:00'!
load
	"Load the #stable version defined for this platform. The #stable version is the version that is recommended to be used on this platform."

	"self load"

	<apiDocumentation>
	^(self project version: #stable) load! !

!ConfigurationOfKEGGeneratorInlining class methodsFor: 'loading' stamp: 'KjellGodo 5/12/2013 11:00'!
loadBleedingEdge
	"Load the latest versions of the mcz files defined for this project. It is not likely that the #bleedingEdge has been tested."

	"self loadBleedingEdge"

	<apiDocumentation>
	^(self project version: #bleedingEdge) load! !

!ConfigurationOfKEGGeneratorInlining class methodsFor: 'loading' stamp: 'KjellGodo 5/12/2013 11:00'!
loadDevelopment
	"Load the #development version defined for this platform. The #development version will change over time and is not expected to be stable."

	"self loadDevelopment"

	<apiDocumentation>
	^(self project version: #development) load! !

!ConfigurationOfKEGGeneratorInlining class methodsFor: 'accessing' stamp: 'KjellGodo 5/12/2013 11:00'!
project

	^self new project! !

!ConfigurationOfKEGGeneratorInlining class methodsFor: 'development support' stamp: 'KjellGodo 5/12/2013 11:00'!
validate
	"Check the configuration for Errors, Critical Warnings, and Warnings (see class comment for MetacelloMCVersionValidator for more information). 
	Errors identify specification issues that will result in unexpected behaviour when you load the configuration. 
	Critical Warnings identify specification issues that may result in unexpected behavior when you load the configuration.
	Warnings identify specification issues that are technically correct, but are worth take a look at."

	"self validate"

	<apiDocumentation>
	self ensureMetacello.
	^ ((Smalltalk at: #MetacelloToolBox) validateConfiguration: self debug: #() recurse: false) explore! !

!ConfigurationOfKEGGeneratorInlining methodsFor: 'accessing' stamp: 'KjellGodo 5/12/2013 18:03'!
baseline10: spec
	<version: '1.0-baseline'>
	spec for: #common do: [
		spec blessing: #release.
		spec repository: 'http://ss3.gemstone.com/ss/KEGGeneratorInlining'.
		( spec project: 'KEGGeneratorBase' with:[ 
				spec
					className: 'ConfigurationOfKEGGeneratorBase' ;
					versionString: #stable ;
					repository: 'http://ss3.gemstone.com/ss/KEGGenerators' ] )."<-----[ loads the 'default' Group without the tests ]"
		( spec project: 'KEGGeneratorBaseTest' copyFrom: 'KEGGeneratorBase' with:[ spec loads:#( 'Tests' ) ] ).
		spec
			package: 'KEGGeneratorInlining' with: [ spec requires: #( 'KEGGeneratorBase' ) ] ;
			package: 'KEGGeneratorInliningTest' with: [ spec requires: #( 'KEGGeneratorBaseTest' ) ] ;
			"<-------------------------------------------------------------------------------------------------[  ]"
			package: 'KEGGeneratorInlining' with:[ spec repository: 'http://ss3.gemstone.com/ss/KEGGeneratorInlining' ] ;
			package: 'KEGGeneratorInliningTest' with:[ spec repository: 'http://ss3.gemstone.com/ss/KEGGeneratorInlining' ] .
		spec
			group: 'default' with: #( 'KEGGeneratorInlining' ) ;
			group: 'Core' with: #( 'KEGGeneratorInlining' ) ;
			group: 'Tests' with: #( 'KEGGeneratorInliningTest' ) ;
			group: 'CompleteWithoutTests' with: #( 'Core' ) ;
			group: 'CompleteWithTests' with: #( 'CompleteWithoutTests' 'Tests' ) ].
		! !

!ConfigurationOfKEGGeneratorInlining methodsFor: 'accessing' stamp: 'KjellGodo 5/12/2013 11:00'!
customProjectAttributes
	 "Edit to return a collection of any custom attributes e.g. for conditional loading: Array with: #'Condition1' with: #'Condition2.
	For more information see: http://code.google.com/p/metacello/wiki/CustomProjectAttrributes"

	^ #().! !

!ConfigurationOfKEGGeneratorInlining methodsFor: 'accessing' stamp: 'KjellGodo 5/12/2013 11:00'!
project

	^ project ifNil: [ | constructor |
		"Bootstrap Metacello if it is not already loaded"
		(self class baseConfigurationClassIfAbsent: []) ensureMetacello.
		"Construct Metacello project"
		project := MetacelloMCProject new projectAttributes: self customProjectAttributes. 
		constructor := (Smalltalk at: #MetacelloVersionConstructor) on: self project: project.
		project loadType: #linear. "change to #atomic if desired"
		project ]! !

!ConfigurationOfKEGGeneratorInlining methodsFor: 'accessing' stamp: 'KjellGodo 5/12/2013 17:30'!
stable: spec 
	<symbolicVersion: #stable>
	
	spec for: #common version: '1.0' .! !

!ConfigurationOfKEGGeneratorInlining methodsFor: 'accessing' stamp: 'KjellGodo 5/12/2013 18:02'!
version10: spec 
	<version: '1.0' imports: #('1.0-baseline')>
	
	spec for: #common do: [
		spec blessing: #'release' .
		spec 
			package: 'KEGGeneratorInlining' with: 'KEGGeneratorInlining-KjellGodo.1' ;
			package: 'KEGGeneratorInliningTest' with: 'KEGGeneratorInliningTest-KjellGodo.1' ;
			project: 'KEGGeneratorBase' with: '1.0' ;
			project: 'KEGGeneratorBaseTest' with: '1.0' ].

! !
